/**
 * Created by pva701 on 12.03.2015.
 */

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

import ru.ifmo.testlib.*;
import ru.ifmo.testlib.Outcome.Type;

public class Check implements Checker {
    private boolean ensureLimitsBi(long bi) {
        final long MAX_BI = 1000000000000000000L;//10^18
        return 0 < bi && bi <= MAX_BI;
    }

    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        String hasAnsJury = ans.nextToken().toLowerCase();
        String hasAnsPart = ouf.nextToken().toLowerCase();
        if (!hasAnsPart.equals("yes") && !hasAnsPart.equals("no")) {
            return new Outcome(Type.PE, "Expected YES or NO, but received " + hasAnsPart);
        }

        boolean canFail = false;
        if (hasAnsJury.equals("no") && hasAnsPart.equals("yes"))//jury == no and part == yes
            canFail = true;
        else if (hasAnsJury.equals("no")) {//jury == no and part == no
            if (!ans.seekEoF()) {
                return new Outcome(Type.FAIL, "Jury printed too much tokens in answer!");
            }
            if (!ouf.seekEoF()) {
                return new Outcome(Type.PE, "Part printed too much tokens in answer!");
            }
            return new Outcome(Type.OK, "Ok. No solution.");
        } else if (hasAnsJury.equals("yes") && hasAnsPart.equals("no")) {
            return new Outcome(Type.WA, "Jury have answer, but participant haven't answer!");
        }
        ans.nextLine();
        ouf.nextLine();

        int n = inf.nextInt();
        int m = inf.nextInt();
        long[] b = new long[n];
        inf.nextLine();

        for (int i = 0; i < n; ++i) {
            b[i] = ouf.nextLong();
            if (!ensureLimitsBi(b[i])) {
                return new Outcome(Type.PE, "Too large or too small b[" + i + "]");
            }
        }
        ouf.nextLine();
        if (!ouf.seekEoF()) {
            return new Outcome(Type.PE, "Too much tokens in answer!");
        }

        for (int i = 0; i < m; ++i) {
            int ki = inf.nextInt();
            long t = 0;
            for (int j = 0; j < ki; ++j) {
                int index = inf.nextInt();
                long value = inf.nextLong();
                --index;
                if (value % b[index] != 0)
                    return new Outcome(Type.WA, "b[" + (index + 1) + "] doesn't satisfy hint #" + (i + 1) + "!");
                if (j == 0)
                    t = value / b[index];
                else if (value / b[index] != t)
                    return new Outcome(Type.WA, "Party's bi don't satisfy hint #" + (i + 1) + "!");
            }
            inf.nextLine();
        }

        if (canFail)
            throw new Outcome(Type.FAIL, "Jury haven't answer, but part found correct answer!");
        return new Outcome(Type.OK, "Ok. Correct answer!");
    }
}
