import java.util.*;
import java.io.*;

public class accounts_iz implements Runnable {
    final static long MX = 1_000_000_000_000_000_000L;

    FastScanner in;
    PrintWriter out;

    long gcd(long a, long b) {
        while (b > 0) {
            a %= b;
            long o = a;
            a = b;
            b = o;
        }
        return a;
    }

    class Edge {
        int to;
        long x, y;
        // b[this] / b[to] = x / y, (x, y) = 1

        Edge() {}
        Edge(int to, long x, long y) {
            long g = gcd(x, y);
            this.to = to;
            this.x = x / g;
            this.y = y / g;
        }
    }

    int n, m;
    ArrayList<Edge> e[];
    boolean vis[];
    long p[], q[], b[];
    long curLcm;
    ArrayList<Integer> visited = new ArrayList<>();

    long add(long a, long b) {
        long res = a + b;
        if (res > MX + 1) {
            res = MX + 1;
        }
        return res;
    }

    long mul(long a, long b) {
        if (a == 0) {
            return 0;
        }
        long res = a * b;
        if (res > MX + 1 || res / a != b) {
            res = MX + 1;
        }
        return res;
    }

    long lcm(long a, long b) {
        if (a == MX + 1 || b == MX + 1) {
            return MX + 1;
        }
        long g = gcd(a, b);
        return mul(a / g, b);
    }

    void dfs1(int v) {
        curLcm = lcm(curLcm, q[v]);
        vis[v] = true;
        visited.add(v);
        for (int i = 0; i < e[v].size(); i++) {
            int to = e[v].get(i).to;
            if (vis[to]) {
                continue;
            }
            Edge edge = e[v].get(i);
            // p[v] / q[v] / (p[to] / q[to]) = x / y
            // p[v] * y / x / q[v] = p[to] / q[to]
            long g1 = gcd(p[v], edge.x);
            long g2 = gcd(edge.y, q[v]);

            p[to] = mul(p[v] / g1, edge.y / g2);
            q[to] = mul(q[v] / g2, edge.x / g1);
            dfs1(edge.to);
        }
    }

    public void solve() throws IOException {
        n = in.nextInt();
        m = in.nextInt();

        e = new ArrayList[n];
        vis = new boolean[n];
        p = new long[n];
        q = new long[n];
        b = new long[n];
        for (int i = 0; i < n; i++) {
            e[i] = new ArrayList<Edge>();
        }
        int k[] = new int[m];
        int c[][] = new int[m][];
        long x[][] = new long[m][];
        for (int i = 0; i < m; i++) {
            k[i] = in.nextInt();
            c[i] = new int[k[i]];
            x[i] = new long[k[i]];
            for (int j = 0; j < k[i]; j++) {
                c[i][j] = in.nextInt() - 1;
                x[i][j] = in.nextLong();
            }
            for (int j = 1; j < k[i]; j++) {
                e[c[i][0]].add(new Edge(c[i][j], x[i][0], x[i][j]));
                e[c[i][j]].add(new Edge(c[i][0], x[i][j], x[i][0]));
            }
        }

        boolean ok = true;
        for (int i = 0; i < n; i++) {
            if (vis[i]) {
                continue;
            }
            p[i] = q[i] = 1;
            curLcm = 1;
            visited.clear();
            dfs1(i);
            for (int j = 0; j < visited.size(); j++) {
                int v = visited.get(j);
                ok &= p[v] <= MX && q[v] <= MX;
                b[v] = curLcm / q[v] * p[v];
                ok &= b[v] <= MX;
            }
        }

        for (int i = 0; i < m; i++) {
            for (int j = 0; j < k[i]; j++) {
                ok &= x[i][j] % b[c[i][j]] == 0;
            }
            for (int j = 1; j < k[i]; j++) {
                long a1 = b[c[i][0]], b1 = b[c[i][j]];
                long a2 = x[i][0], b2 = x[i][j];
                long g1 = gcd(a1, b1);
                long g2 = gcd(a2, b2);
                ok &= a1 / g1 == a2 / g2 && b1 / g1 == b2 / g2;
            }
        }

        if (ok) {
            out.println("YES");
            for (int i = 0; i < n; i++) {
                out.print(b[i] + (i + 1 == n ? "\n" : " "));
            }
        } else {
            out.println("NO");
        }
    }

    public void run() {
        try {
            in = new FastScanner(new File("accounts.in"));
            out = new PrintWriter(new File("accounts.out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }
    }

    public static void main(String[] arg) {
        new Thread(null, new accounts_iz(), "", 1 << 26).start();
    }
}
