/* Solution with O(n^2) complexity */
/* Should get 60 points */
#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>

typedef long long ll;

const ll INF = (ll) 1e18;

using namespace std;

#define TASK "cakes"

int main()
{
    freopen(TASK ".in", "r", stdin);
    freopen(TASK ".out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, t;
    cin >> n >> t;

    vector <pair <int, int> > v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].first >> v[i].second;
    }

    vector <vector <ll> > dp(n + 1, vector <ll>(n + 1, INF));
    dp[0][0] = 0;

    int best = 0;
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= i; j++) {
            if (dp[i][j] == INF) continue;
            if (i > 0) {
                ll time = dp[i][j] + v[i - 1].first;
                if (time <= t) {
                    best = max(best, j);
                }
            }
            if (i == n) continue;
            dp[i + 1][j] = min(dp[i + 1][j], dp[i][j]);
            dp[i + 1][j + 1] = min(dp[i + 1][j + 1], dp[i][j] + v[i].second);
        }
    }

    cout << best << endl;

    return 0;
}
