/* Solution with O(n log n) complexity, with assert that t > x_i */
/* Should get 0 points */
#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <cassert>

typedef long long ll;

using namespace std;

#define TASK "cakes"

struct cmp
{
    vector <pair <int, int> > const& v;
    cmp(vector <pair <int, int> > const& v)
        : v(v) {}

    bool operator()(int const& a, int const& b) const
    {
        return v[a].second < v[b].second
           || (v[a].second == v[b].second && a < b);
    }
};

int main()
{
    freopen(TASK ".in", "r", stdin);
    freopen(TASK ".out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, t;
    cin >> n >> t;

    vector <pair <int, int> > v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].first >> v[i].second;
        assert(v[i].second <= t);
    }
    int best = 0;
    set <int, cmp> q((cmp(v)));
    ll sum = 0;

    for (int i = 0; i < n; i++) {
        q.insert(i);
        sum += v[i].second;
        while (!q.empty() && sum + v[i].first > t) {
            int er = *q.rbegin();
            q.erase(er);
            sum -= v[er].second;
        }

        if (sum + v[i].first <= t) {
            best = max(best, (int) q.size());
        }
    }

    cout << best << endl;

    return 0;
}
