import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;
import static ru.ifmo.testlib.Outcome.Type.*;

public class Check implements Checker {
    public Outcome outcome(Outcome.Type type, final String format, final Object... args) {
        return new Outcome(type, String.format(format, args));
    }

    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        int n = inf.nextInt();
        inf.nextInt();
        for (int i = 0; i < n; i++) {
            inf.nextInt();
        }
        int m = inf.nextInt();
        int queries = 0;
        for (int i = 0; i < m; i++) {
            int type = inf.nextInt();
            if (type == 1 || type == 3) { //push or query
                inf.nextInt();
            }
            if (type == 3) { //query
                queries++;
            }
        }
        for (int i = 0; i < queries; i++) {
            int pAns = ouf.nextInt();
            int jAns = ans.nextInt();
            if (pAns != jAns) {
                return outcome(WA, String.format("%d-th query: Expected %d, found %d", i + 1, jAns, pAns));
            }
       }
       return outcome(OK, String.format("Correct, %d numbers", queries));
    }
}
