import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;
import static ru.ifmo.testlib.Outcome.Type.*;

public class Check implements Checker {
    public Outcome outcome(Outcome.Type type, final String format) {
        return new Outcome(type, format);
    }

    boolean check(String ans, InStream in, int n, int[] a) {
        if (ans.equals("NO")) {
            return true;
        }
        if (!ans.equals("YES")) {
            return false;
        }
        int[] b = new int[n];
        int sum = 0;
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            b[i] = in.nextInt();
            if (b[i] != 1 && b[i] != 2) {
                return false;
            }
            if (b[i] == 1) {
                cnt++;
                sum += a[i];
            }
        }
        return sum == n - cnt;
    }

    public Outcome test(InStream inf, InStream ouf, InStream ans) {
	int n = inf.nextInt();
        int a[] = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = inf.nextInt();
        }
        String ja = ans.nextToken();
        boolean jaCorrect = check(ja, ans, n, a);
        String pa = ouf.nextToken();
        boolean paCorrect = check(pa, ouf, n, a);

        if (!jaCorrect) {
            return outcome(FAIL, String.format("incorrect jury answer"));
        }

        if (ja.equals("NO") && pa.equals("YES") && paCorrect) {
            return outcome(FAIL, String.format("jury did'n find answer, but participant did"));
        }

        if (!ja.equals(pa)) {
            return outcome(WA, String.format("expected %s, found %s", ja, pa));
        }

        if (!paCorrect) {
            return outcome(WA, String.format("participant's answer is incorrect"));
        }

        return outcome(OK, String.format("n = %d", n));
    }
}
